# zbot/plugs/spider.py
#
#


""" 
    spider .. spider websites and make an index into them.

    taken from http://code.activestate.com/recipes/576551-simple-web-crawler/

"""

## IMPORTS

from zbot import TaskRunner, kernel, Object
from zbot.utils import striphtml

import urllib.request, urllib.error, urllib.parse
import urllib.parse
import optparse
import logging
import time
import math
import os
import re
import sys

from queue import Queue, Empty as QueueEmpty
from cgi import escape
from collections import deque 
from traceback import format_exc

## DEFINES

running = []

## Url class

class Url(Object):

    def __init__(self, url, *args, **kwargs):
        self.url = url
        self.urls = []
        self.parse()

    def parse(self, url=None):
        """
        
        Attribute	Index	Value			Value if not present
        scheme		0	URL scheme specifier	empty string
        netloc		1	Network location part	empty string
        path		2	Hierarchical path	empty string
        query		3	Query component		empty string
        fragment	4	Fragment identifier	empty string
        
        """
        if url: self.url = url
        self.parsed = urllib.parse.urlsplit(url or self.url)
        self.target = self.parsed[2].split("/")
        if "." in self.target[-1]:
            self.basepath = "/".join(self.target[:-1])
            self.file = self.target[-1]
        else: self.basepath = self.parsed[2] ; self.file = None
        if self.basepath.endswith("/"): self.basepath = self.basepath[:-1]
        self.base = urllib.parse.urlunsplit((self.parsed[0], self.parsed[1], self.basepath , "", ""))
        self.root = urllib.parse.urlunsplit((self.parsed[0], self.parsed[1], "", "", ""))

    def fetch(self, *args, **kwargs):
        self.html = geturl2(self.url)
        self.status = self.html.info.status
        self.txt = striphtml(self.html)
        self.lastpolled = time.time()
        self.parse()
        return self.html

    def geturls(self):
        if not self.html: self.fetch()
        urls = []
        from ggz.imports import getBeautifulSoup
        s = bs4.BeautifulSoup(self.html)
        tags = s('a')
        for tag in tags:
           href = tag.get("href")
           if href:
               href = href.split("#")[0]
               if not href: continue
               if not href.endswith(".html"): continue
               if ".." in href: continue
               if href.startswith("mailto"): continue
               if not "http" in href:
                    if href.startswith("/"): href = self.root + href
                    else: href = self.base + "/" + href
               if not self.root in href: logging.warn("%s not in %s" % (self.root, href)) ; continue
               if href not in urls: urls.append(href)
        logging.warn("found %s urls" % len(urls))
        return urls

## Spider class

class Spider(TaskRunner):

    def __init__(self, *args, skip=True):
        TaskRunner.__init__(self, *args)
        self.url = Url(args[0])
        self.errors = []
        self.urls = []
        self.followed = []
        self.skip = skip
        self.sTime = time.time()
        self.eTime = 0
        self.tTime = 0

    def do_fetch(self, event, url, depth, speed=5):
        if depth < 0: return
        if not self.url.base in url: logging.warn("skipping %s (%s)" % (url, self.url.base)) ; return
        if url in self.errors: logging.warn("skipping %s" % url) ; return
        urls = []
        linknr = 0
        follownr = 0
        n = 0
        try:
            if url not in self.urls:
                self.urls.append(url)
                page = Url(url)
                time.sleep(10-speed)
                content = page.fetch()
                event._raw("fetched %s - %s - %s" % (url, len(content), content.status))
                try:
                    o = Object()
                    o.html = striphtml(content)
                    o.save()
                except Exception as ex: error()
                for p in page.geturls():
                    if not p in self.errors: self.put(6, event, p, depth-1, speed-1)
            if not self.queue.qsize(): self.stop()
        except Exception as e:
            logging.warn("ERROR: Can't process url '%s' (%s)" % (url, e))
            self.errors.append(url)
            error()
            if len(self.errors) > 10: self.stop()

def do_spider(event):
    if not event.args: event.reply("<url> [<depth>]") ; return
    url = event.args[0]
    try: depth = int(event.args[1])
    except ValueError: event.reply("depth need to be an integer") ; return 
    except IndexError: depth = 3
    spider = Spider(url)
    if not spider in running: running.append(spider)
    thr = spider.start()
    logging.warn("spider %s" % str(running))
    event.reply("calling fetcher on %s" % time.ctime(spider.sTime))
    spider.put(5, event, url, depth, 9)
    
kernel.cmnds.register("spider", do_spider)

def do_spiderstop(event):
    r = len(running)
    for spider in running: spider.stop()
    event.reply("stopped %s spiders" % r)
    
kernel.cmnds.register("spider-stop", do_spiderstop)
